diff -Nru config/ac-macros/dtrace.m4 config/ac-macros/dtrace.m4
--- config/ac-macros/dtrace.m4	1970-01-01 01:00:00.000000000 +0100
+++ config/ac-macros/dtrace.m4	2011-05-27 10:50:57.000000000 +0200
@@ -0,0 +1,43 @@
+dnl ---------------------------------------------------------------------------
+dnl Macro: DTRACE_TEST
+dnl ---------------------------------------------------------------------------
+AC_ARG_ENABLE(dtrace,
+    AC_HELP_STRING([--enable-dtrace],[Build with support for DTrace.]),
+    [
+      ENABLE_DTRACE="$enable_dtrace"
+    ],
+    [
+      ENABLE_DTRACE="yes" 
+    ]
+)
+DTRACEFLAGS=""
+HAVE_DTRACE=""
+HAVE_DTRACE_DASH_G=""
+if test "$ENABLE_DTRACE" = "yes"; then
+  AC_PATH_PROG(DTRACE, dtrace, [not found], [$PATH:/usr/sbin])
+  if test "$DTRACE" = "not found"; then
+    ENABLE_DTRACE="no"
+  else
+    AC_DEFINE([HAVE_DTRACE], [1], [Defined to 1 if DTrace support is enabled])
+    case "$target_os" in
+      *solaris*)
+        HAVE_DTRACE_DASH_G="yes"
+        case "$CFLAGS" in
+          *-m64*)
+            DTRACEFLAGS="$DTRACEFLAGS -64"
+            ;;
+        esac
+        ;;
+      *)
+        HAVE_DTRACE_DASH_G="no"
+        ;;
+    esac
+  fi
+fi
+AC_SUBST(DTRACEFLAGS)
+AC_SUBST(HAVE_DTRACE)
+AM_CONDITIONAL([HAVE_DTRACE], [ test "$ENABLE_DTRACE" = "yes" ])
+AM_CONDITIONAL([HAVE_DTRACE_DASH_G], [ test "$HAVE_DTRACE_DASH_G" = "yes" ])
+dnl ---------------------------------------------------------------------------
+dnl End Macro: DTRACE_TEST
+dnl ---------------------------------------------------------------------------
diff -Nru config.h.in config.h.in
--- config.h.in	2011-05-27 11:03:51.000000000 +0200
+++ config.h.in	2011-05-27 10:51:57.000000000 +0200
@@ -268,6 +268,9 @@
 /* Define to 1 if you don't have `vprintf' but do have `_doprnt.' */
 #undef HAVE_DOPRNT
 
+/* Defined to 1 if DTrace support is enabled */
+#undef HAVE_DTRACE
+
 /* Access checks in embedded library */
 #undef HAVE_EMBEDDED_PRIVILEGE_CONTROL
 
diff -Nru configure.in configure.in
--- configure.in	2011-05-27 11:02:46.000000000 +0200
+++ configure.in	2011-05-27 10:50:57.000000000 +0200
@@ -50,6 +50,7 @@
 sinclude(config/ac-macros/check_cpu.m4)
 sinclude(config/ac-macros/character_sets.m4)
 sinclude(config/ac-macros/compiler_flag.m4)
+sinclude(config/ac-macros/dtrace.m4)
 sinclude(config/ac-macros/plugins.m4)
 sinclude(config/ac-macros/ha_ndbcluster.m4)
 sinclude(config/ac-macros/large_file.m4)
diff -Nru include/Makefile.am include/Makefile.am
--- include/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ include/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -67,5 +67,18 @@
 dist-hook:
 	$(RM) -f $(distdir)/mysql_version.h $(distdir)/my_config.h
 
+
+if HAVE_DTRACE
+BUILT_SOURCES += probes_mysql_dtrace.h
+CLEANFILES += probes_mysql_dtrace.h
+DTRACEPROVIDER = $(top_srcdir)/sql/probes_mysql.d
+
+probes_mysql_dtrace.h: $(DTRACEPROVIDER)
+	$(DTRACE) $(DTRACEFLAGS) -h -s $^ -o $@
+endif
+
+probes_mysql_nodtrace.h: $(DTRACEPROVIDER)
+	$(top_srcdir)/scripts/dheadgen.pl -f $^ > $@
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru libmysql/Makefile.shared libmysql/Makefile.shared
--- libmysql/Makefile.shared	2011-05-27 11:02:47.000000000 +0200
+++ libmysql/Makefile.shared	2011-05-27 10:50:57.000000000 +0200
@@ -89,7 +89,8 @@
 			-DDEFAULT_HOME_ENV=MYSQL_HOME \
 			-DDEFAULT_GROUP_SUFFIX_ENV=MYSQL_GROUP_SUFFIX \
 			-DDEFAULT_SYSCONFDIR="\"$(sysconfdir)\"" \
-			-DSHAREDIR="\"$(MYSQLSHAREdir)\"" $(target_defs)
+			-DSHAREDIR="\"$(MYSQLSHAREdir)\"" -DDISABLE_DTRACE \
+			$(target_defs)
 
 if HAVE_YASSL
 yassl_las = $(top_builddir)/extra/yassl/src/libyassl.la \
diff -Nru mysys/Makefile.am mysys/Makefile.am
--- mysys/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ mysys/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -126,5 +126,21 @@
 	$(LINK) $(FLAGS) -DMAIN  ./test_base64.c $(LDADD) $(LIBS)
 	$(RM) -f ./test_base64.c
 
+if HAVE_DTRACE_DASH_G
+abs_top_srcdir = @abs_top_srcdir@
+libmysys_a_LIBADD += probes_mysql.o
+libmysys_a_DEPENDENCIES += probes_mysql.o dtrace_files dtrace_providers
+CLEANFILES = probes_mysql.o dtrace_files dtrace_providers
+DTRACEFILES = mf_keycache.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru mysys/mf_keycache.c mysys/mf_keycache.c
--- mysys/mf_keycache.c	2011-05-27 11:02:47.000000000 +0200
+++ mysys/mf_keycache.c	2011-05-27 10:50:57.000000000 +0200
@@ -109,6 +109,7 @@
 #include <my_bit.h>
 #include <errno.h>
 #include <stdarg.h>
+#include "probes_mysql.h"
 
 /*
   Some compilation flags have been added specifically for this module
@@ -2539,6 +2540,15 @@
     uint status;
     int page_st;
 
+    if (MYSQL_KEYCACHE_READ_START_ENABLED())
+      {
+	MYSQL_KEYCACHE_READ_START(my_filename(file), length,
+				  (ulong) (keycache->blocks_used *
+					   keycache->key_cache_block_size),
+				  (ulong) (keycache->blocks_unused *
+					   keycache->key_cache_block_size));
+      }
+
     /*
       When the key cache is once initialized, we use the cache_lock to
       reliably distinguish the cases of normal operation, resizing, and
@@ -2588,6 +2598,9 @@
 
       /* Request the cache block that matches file/pos. */
       keycache->global_cache_r_requests++;
+
+      MYSQL_KEYCACHE_READ_BLOCK(keycache->key_cache_block_size);
+
       block=find_key_block(keycache, file, filepos, level, 0, &page_st);
       if (!block)
       {
@@ -2607,6 +2620,7 @@
       {
         if (page_st != PAGE_READ)
         {
+	  MYSQL_KEYCACHE_READ_MISS();
           /* The requested page is to be read into the block buffer */
           read_block(keycache, block,
                      keycache->key_cache_block_size, read_length+offset,
@@ -2631,6 +2645,10 @@
           my_errno= -1;
           block->status|= BLOCK_ERROR;
         }
+	else
+	  {
+	    MYSQL_KEYCACHE_READ_HIT();
+	  }
       }
 
       /* block status may have added BLOCK_ERROR in the above 'if'. */
@@ -2675,14 +2693,31 @@
 #ifndef THREAD
       /* This is only true if we where able to read everything in one block */
       if (return_buffer)
-	DBUG_RETURN(block->buffer);
+	{
+	  if (MYSQL_KEYCACHE_READ_DONE_ENABLED())
+	    {
+	      MYSQL_KEYCACHE_READ_DONE((ulong) (keycache->blocks_used *
+						keycache->key_cache_block_size),
+				       (ulong) (keycache->blocks_unused *
+						keycache->key_cache_block_size));
+	    }
+	  DBUG_RETURN(block->buffer);
+	}
+    }
 #endif
   next_block:
       buff+= read_length;
       filepos+= read_length+offset;
       offset= 0;
 
-    } while ((length-= read_length));
+  } while ((length-= read_length));
+  if (MYSQL_KEYCACHE_READ_DONE_ENABLED())
+  {
+    MYSQL_KEYCACHE_READ_DONE((ulong) (keycache->blocks_used *
+				      keycache->key_cache_block_size),
+			     (ulong) (keycache->blocks_unused *
+				      keycache->key_cache_block_size));
+  }
     goto end;
   }
 
@@ -3011,6 +3046,15 @@
     uint offset;
     int page_st;
 
+    if (MYSQL_KEYCACHE_WRITE_START_ENABLED())
+      {
+	MYSQL_KEYCACHE_WRITE_START(my_filename(file), length,
+				   (ulong) (keycache->blocks_used *
+					    keycache->key_cache_block_size),
+				   (ulong) (keycache->blocks_unused *
+					    keycache->key_cache_block_size));
+      }
+
     /*
       When the key cache is once initialized, we use the cache_lock to
       reliably distinguish the cases of normal operation, resizing, and
@@ -3046,6 +3090,9 @@
       /* Cache could be disabled in a later iteration. */
       if (!keycache->can_be_used)
 	goto no_key_cache;
+
+      MYSQL_KEYCACHE_WRITE_BLOCK(keycache->key_cache_block_size);
+
       /* Start writing at the beginning of the cache block. */
       filepos-= offset;
       /* Do not write beyond the end of the cache block. */
@@ -3249,6 +3296,15 @@
     dec_counter_for_resize_op(keycache);
     keycache_pthread_mutex_unlock(&keycache->cache_lock);
   }
+
+  if (MYSQL_KEYCACHE_WRITE_DONE_ENABLED())
+    {
+      MYSQL_KEYCACHE_WRITE_DONE((ulong) (keycache->blocks_used *
+					 keycache->key_cache_block_size),
+				(ulong) (keycache->blocks_unused *
+					 keycache->key_cache_block_size));
+    }
+
 #if !defined(DBUG_OFF) && defined(EXTRA_DEBUG)
   DBUG_EXECUTE("exec",
                test_key_cache(keycache, "end of key_cache_write", 1););
diff -Nru server-tools/instance-manager/Makefile.am server-tools/instance-manager/Makefile.am
--- server-tools/instance-manager/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ server-tools/instance-manager/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -49,6 +49,7 @@
 	$(top_builddir)/sql/client.$(OBJEXT)
 
 CLEANFILES= net_serv.cc client_settings.h
+DEFS = -DMYSQL_INSTANCE_MANAGER -DMYSQL_SERVER -DDISABLE_DTRACE
 
 net_serv.cc:
 	rm -f net_serv.cc
diff -Nru sql/Makefile.am sql/Makefile.am
--- sql/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ sql/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -28,6 +28,22 @@
 libexec_PROGRAMS =	mysqld
 EXTRA_PROGRAMS =	gen_lex_hash
 bin_PROGRAMS =		mysql_tzinfo_to_sql
+DTRACEFILES =           filesort.o \
+                        .libs/libndb_la-ha_ndbcluster.o \
+                        handler.o \
+                        mysqld.o \
+                        net_serv.o \
+                        scheduler.o \
+                        sp_head.o \
+                        sql_cache.o \
+                        sql_connect.o \
+                        sql_cursor.o \
+                        sql_delete.o \
+                        sql_insert.o \
+                        sql_parse.o \
+                        sql_prepare.o \
+                        sql_select.o \
+                        sql_update.o
 
 noinst_LTLIBRARIES=	libndb.la \
 			udf_example.la
@@ -122,7 +138,7 @@
 			sql_builtin.cc sql_tablespace.cc partition_info.cc \
 			sql_servers.cc event_parse_data.cc
 
-nodist_mysqld_SOURCES =	mini_client_errors.c pack.c client.c my_time.c my_user.c 
+nodist_mysqld_SOURCES =	mini_client_errors.c pack.c client.c my_time.c my_user.c
 
 libndb_la_CPPFLAGS=	@ndbcluster_includes@
 libndb_la_SOURCES=	ha_ndbcluster.cc \
@@ -188,5 +204,32 @@
 	test ! -f mysqld-debug.sym.gz   || $(INSTALL_DATA)    mysqld-debug.sym.gz   $(DESTDIR)$(pkglibdir)
 	test ! -f mysqld.sym.gz         || $(INSTALL_DATA)    mysqld.sym.gz         $(DESTDIR)$(pkglibdir)
 
+if HAVE_DTRACE_DASH_G
+libndb_la_LIBADD = probes_libndb.o
+libndb_la_DEPENDENCIES = dtrace_files dtrace_providers probes_libndb.o
+abs_top_srcdir = @abs_top_srcdir@
+mysqld_LDADD += probes_all.o
+mysqld_DEPENDENCIES += dtrace_files dtrace_providers probes_all.o
+CLEANFILES += dtrace_files dtrace_providers probes_all.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+
+DTRACEDIRS = . ../mysys $(patsubst %,$(top_builddir)/storage/%,@mysql_se_dirs@) backup
+
+.libs/libndb_la-ha_ndbcluster.o : libndb_la-ha_ndbcluster.lo
+
+probes_all.o: probes_mysql.d $(DTRACEFILES)
+	providers=`(for i in $(DTRACEDIRS); do cat $$i/dtrace_providers 2>/dev/null; done) | tr " " "\n" | sort | uniq | sed -e '/^$$/d' -e 's/^/-s /'`; \
+	objects=`for i in $(DTRACEDIRS); do f=\`cat $$i/dtrace_files 2>/dev/null\`; for j in $$f; do test -f $$i/$$j && echo "$$i/$$j "; done; done`; \
+	$(DTRACE) $(DTRACEFLAGS) -G $$providers $$objects -o $@
+
+probes_libndb.o: probes_mysql.d .libs/libndb_la-ha_ndbcluster.o
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< .libs/libndb_la-ha_ndbcluster.o -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru sql/filesort.cc sql/filesort.cc
--- sql/filesort.cc	2011-05-27 11:02:46.000000000 +0200
+++ sql/filesort.cc	2011-05-27 10:50:57.000000000 +0200
@@ -27,6 +27,7 @@
 #endif
 #include <m_ctype.h>
 #include "sql_sort.h"
+#include "probes_mysql.h"
 
 #ifndef THREAD
 #define SKIP_DBUG_IN_FILESORT
@@ -121,6 +122,7 @@
   TABLE_LIST *tab= table->pos_in_table_list;
   Item_subselect *subselect= tab ? tab->containing_subselect() : 0;
 
+  MYSQL_FILESORT_START(table->s->db.str, table->s->table_name.str);
   /*
    Release InnoDB's adaptive hash index latch (if holding) before
    running a sort.
@@ -331,7 +333,10 @@
 #endif
   memcpy(&table->sort, &table_sort, sizeof(FILESORT_INFO));
   DBUG_PRINT("exit",("records: %ld", (long) records));
-  DBUG_RETURN(error ? HA_POS_ERROR : records);
+  if (error)
+    records= HA_POS_ERROR;
+  MYSQL_FILESORT_DONE(error, records);
+  DBUG_RETURN(records);
 } /* filesort */
 
 
diff -Nru sql/ha_ndbcluster.cc sql/ha_ndbcluster.cc
--- sql/ha_ndbcluster.cc	2011-05-27 11:02:46.000000000 +0200
+++ sql/ha_ndbcluster.cc	2011-05-27 10:50:57.000000000 +0200
@@ -41,6 +41,7 @@
 #include "ha_ndbcluster_tables.h"
 
 #include <mysql/plugin.h>
+#include "probes_mysql.h"
 
 #ifdef ndb_dynamite
 #undef assert
@@ -3601,7 +3602,9 @@
 {
   key_range start_key;
   bool descending= FALSE;
+  int rc;
   DBUG_ENTER("ha_ndbcluster::index_read");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   DBUG_PRINT("enter", ("active_index: %u, key_len: %u, find_flag: %d", 
                        active_index, key_len, find_flag));
 
@@ -3619,43 +3622,61 @@
   default:
     break;
   }
-  DBUG_RETURN(read_range_first_to_buf(&start_key, 0, descending,
-                                      m_sorted, buf));
+  rc= read_range_first_to_buf(&start_key, 0, descending,
+			      m_sorted, buf);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_ndbcluster::index_next(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("ha_ndbcluster::index_next");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   ha_statistic_increment(&SSV::ha_read_next_count);
-  DBUG_RETURN(next_result(buf));
+  rc= next_result(buf);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_ndbcluster::index_prev(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("ha_ndbcluster::index_prev");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   ha_statistic_increment(&SSV::ha_read_prev_count);
-  DBUG_RETURN(next_result(buf));
+  rc= next_result(buf);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_ndbcluster::index_first(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("ha_ndbcluster::index_first");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   ha_statistic_increment(&SSV::ha_read_first_count);
   // Start the ordered index scan and fetch the first row
 
   // Only HA_READ_ORDER indexes get called by index_first
-  DBUG_RETURN(ordered_index_scan(0, 0, TRUE, FALSE, buf, NULL));
+  rc= ordered_index_scan(0, 0, TRUE, FALSE, buf, NULL);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_ndbcluster::index_last(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("ha_ndbcluster::index_last");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   ha_statistic_increment(&SSV::ha_read_last_count);
-  DBUG_RETURN(ordered_index_scan(0, 0, TRUE, TRUE, buf, NULL));
+  rc= ordered_index_scan(0, 0, TRUE, TRUE, buf, NULL);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 int ha_ndbcluster::index_read_last(uchar * buf, const uchar * key, uint key_len)
@@ -3748,15 +3769,23 @@
                                     bool eq_r, bool sorted)
 {
   uchar* buf= table->record[0];
+  int rc;
   DBUG_ENTER("ha_ndbcluster::read_range_first");
-  DBUG_RETURN(read_range_first_to_buf(start_key, end_key, FALSE,
-                                      sorted, buf));
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  rc= read_range_first_to_buf(start_key, end_key, FALSE,
+                              sorted, buf);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 int ha_ndbcluster::read_range_next()
 {
+  int rc;
   DBUG_ENTER("ha_ndbcluster::read_range_next");
-  DBUG_RETURN(next_result(table->record[0]));
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  rc= next_result(table->record[0]);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
@@ -3839,12 +3868,18 @@
 
 int ha_ndbcluster::rnd_next(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("rnd_next");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 0);
+
   ha_statistic_increment(&SSV::ha_read_rnd_next_count);
 
   if (!m_active_cursor)
-    DBUG_RETURN(full_table_scan(buf));
-  DBUG_RETURN(next_result(buf));
+    rc= full_table_scan(buf);
+  else
+    rc= next_result(buf);
+  MYSQL_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
@@ -3857,12 +3892,14 @@
 int ha_ndbcluster::rnd_pos(uchar *buf, uchar *pos)
 {
   DBUG_ENTER("rnd_pos");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 0);
   ha_statistic_increment(&SSV::ha_read_rnd_count);
   // The primary key for the record is stored in pos
   // Perform a pk_read using primary key "index"
   {
     part_id_range part_spec;
     uint key_length= ref_length;
+    int rc;
     if (m_use_partition_function)
     {
       if (table_share->primary_key == MAX_KEY)
@@ -3889,7 +3926,9 @@
       DBUG_PRINT("info", ("partition id %u", part_spec.start_part));
     }
     DBUG_DUMP("key", pos, key_length);
-    DBUG_RETURN(pk_read(pos, key_length, buf, part_spec.start_part));
+    rc= pk_read(pos, key_length, buf, part_spec.start_part);
+    MYSQL_READ_ROW_DONE(rc);
+    DBUG_RETURN(rc);
   }
 }
 
diff -Nru sql/handler.cc sql/handler.cc
--- sql/handler.cc	2011-05-27 11:02:46.000000000 +0200
+++ sql/handler.cc	2011-05-27 10:50:57.000000000 +0200
@@ -27,6 +27,7 @@
 #include "rpl_filter.h"
 #include <myisampack.h>
 #include <errno.h>
+#include <probes_mysql.h>
 
 #ifdef WITH_PARTITION_STORAGE_ENGINE
 #include "ha_partition.h"
@@ -4556,6 +4557,27 @@
   */
   DBUG_ASSERT(next_insert_id == 0);
 
+  if (MYSQL_HANDLER_RDLOCK_START_ENABLED() ||
+      MYSQL_HANDLER_WRLOCK_START_ENABLED() ||
+      MYSQL_HANDLER_UNLOCK_START_ENABLED())
+    {
+      if (lock_type == F_RDLCK)
+	{
+	  MYSQL_HANDLER_RDLOCK_START(table_share->db.str,
+				     table_share->table_name.str);
+	}
+      else if (lock_type == F_WRLCK)
+	{
+	  MYSQL_HANDLER_WRLOCK_START(table_share->db.str,
+				     table_share->table_name.str);
+	}
+      else if (lock_type == F_UNLCK)
+	{
+	  MYSQL_HANDLER_UNLOCK_START(table_share->db.str,
+				     table_share->table_name.str);
+	}
+    }
+
   /*
     We cache the table flags if the locking succeeded. Otherwise, we
     keep them as they were when they were fetched in ha_open().
@@ -4563,6 +4585,25 @@
   int error= external_lock(thd, lock_type);
   if (error == 0)
     cached_table_flags= table_flags();
+
+  if (MYSQL_HANDLER_RDLOCK_DONE_ENABLED() ||
+      MYSQL_HANDLER_WRLOCK_DONE_ENABLED() ||
+      MYSQL_HANDLER_UNLOCK_DONE_ENABLED())
+    {
+      if (lock_type == F_RDLCK)
+	{
+	  MYSQL_HANDLER_RDLOCK_DONE(error);
+	}
+      else if (lock_type == F_WRLCK)
+	{
+	  MYSQL_HANDLER_WRLOCK_DONE(error);
+	}
+      else if (lock_type == F_UNLCK)
+	{
+	  MYSQL_HANDLER_UNLOCK_DONE(error);
+	}
+    }
+
   DBUG_RETURN(error);
 }
 
@@ -4595,9 +4636,13 @@
   Log_func *log_func= Write_rows_log_event::binlog_row_logging_function;
   DBUG_ENTER("handler::ha_write_row");
 
+  MYSQL_INSERT_ROW_START(table_share->db.str, table_share->table_name.str);
   mark_trx_read_write();
 
-  if (unlikely(error= write_row(buf)))
+  error= write_row(buf);
+  MYSQL_INSERT_ROW_DONE(error);
+
+  if (unlikely(error != 0))
     DBUG_RETURN(error);
   if (unlikely(error= binlog_log_row(table, 0, buf, log_func)))
     DBUG_RETURN(error); /* purecov: inspected */
@@ -4614,14 +4659,18 @@
     Some storage engines require that the new record is in record[0]
     (and the old record is in record[1]).
    */
+  DBUG_ENTER("handler::ha_update_row");
   DBUG_ASSERT(new_data == table->record[0]);
+  MYSQL_UPDATE_ROW_START(table_share->db.str, table_share->table_name.str);
 
   mark_trx_read_write();
+  error= update_row(old_data, new_data);
+  MYSQL_UPDATE_ROW_DONE(error);
 
-  if (unlikely(error= update_row(old_data, new_data)))
+  if (unlikely(error != 0))
     return error;
   if (unlikely(error= binlog_log_row(table, old_data, new_data, log_func)))
-    return error;
+    return(error);
   return 0;
 }
 
@@ -4630,9 +4679,12 @@
   int error;
   Log_func *log_func= Delete_rows_log_event::binlog_row_logging_function;
 
+  MYSQL_DELETE_ROW_START(table_share->db.str, table_share->table_name.str);
   mark_trx_read_write();
+  error= delete_row(buf);
+  MYSQL_DELETE_ROW_DONE(error);
 
-  if (unlikely(error= delete_row(buf)))
+  if (unlikely(error != 0))
     return error;
   if (unlikely(error= binlog_log_row(table, buf, 0, log_func)))
     return error;
@@ -4640,7 +4692,6 @@
 }
 
 
-
 /** @brief
   use_hidden_primary_key() is called in case of an update/delete when
   (table_flags() and HA_PRIMARY_KEY_REQUIRED_FOR_DELETE) is defined
diff -Nru sql/mysqld.cc sql/mysqld.cc
--- sql/mysqld.cc	2011-05-27 11:02:47.000000000 +0200
+++ sql/mysqld.cc	2011-05-27 10:50:57.000000000 +0200
@@ -31,6 +31,8 @@
 
 #include "rpl_injector.h"
 
+#include "probes_mysql.h"
+
 #ifdef HAVE_SYS_PRCTL_H
 #include <sys/prctl.h>
 #endif
@@ -1786,6 +1788,12 @@
   }
   if (lock)
     (void) pthread_mutex_unlock(&LOCK_thread_count);
+  /* Workaround for problem with DTrace probes and tail call optimization */
+  if (MYSQL_CONNECTION_DONE_ENABLED())
+    {
+      MYSQL_CONNECTION_DONE((int) errcode, thd->thread_id);
+      sleep(0);
+    }
   DBUG_VOID_RETURN;
 }
 #endif /* EMBEDDED_LIBRARY */
diff -Nru sql/net_serv.cc sql/net_serv.cc
--- sql/net_serv.cc	2011-05-27 11:02:48.000000000 +0200
+++ sql/net_serv.cc	2011-05-27 10:50:57.000000000 +0200
@@ -58,6 +58,7 @@
 #define MYSQL_CLIENT
 #endif /*EMBEDDED_LIBRARY */
 
+#include <probes_mysql.h>
 
 /*
   The following handles the differences when this is linked between the
@@ -368,6 +369,10 @@
 my_net_write(NET *net,const uchar *packet,size_t len)
 {
   uchar buff[NET_HEADER_SIZE];
+  my_bool rc;
+
+  MYSQL_NET_WRITE_START(len);
+
   if (unlikely(!net->vio)) /* nowhere to write */
     return 0;
   /*
@@ -382,7 +387,10 @@
     buff[3]= (uchar) net->pkt_nr++;
     if (net_write_buff(net, buff, NET_HEADER_SIZE) ||
 	net_write_buff(net, packet, z_size))
-      return 1;
+      {
+	MYSQL_NET_WRITE_DONE(1);
+	return 1;
+      }
     packet += z_size;
     len-=     z_size;
   }
@@ -390,11 +398,16 @@
   int3store(buff,len);
   buff[3]= (uchar) net->pkt_nr++;
   if (net_write_buff(net, buff, NET_HEADER_SIZE))
-    return 1;
+    {
+      MYSQL_NET_WRITE_DONE(1);
+      return 1;
+    }
 #ifndef DEBUG_DATA_PACKETS
   DBUG_DUMP("packet_header", buff, NET_HEADER_SIZE);
 #endif
-  return test(net_write_buff(net,packet,len));
+  rc= test(net_write_buff(net,packet,len));
+  MYSQL_NET_WRITE_DONE(rc);
+  return rc;
 }
 
 /**
@@ -432,9 +445,12 @@
   size_t length=len+1+head_len;			/* 1 extra byte for command */
   uchar buff[NET_HEADER_SIZE+1];
   uint header_size=NET_HEADER_SIZE+1;
+  my_bool rc;
   DBUG_ENTER("net_write_command");
   DBUG_PRINT("enter",("length: %lu", (ulong) len));
 
+  MYSQL_NET_WRITE_START(length);
+
   buff[4]=command;				/* For first packet */
 
   if (length >= MAX_PACKET_LENGTH)
@@ -448,7 +464,10 @@
       if (net_write_buff(net, buff, header_size) ||
 	  net_write_buff(net, header, head_len) ||
 	  net_write_buff(net, packet, len))
-	DBUG_RETURN(1);
+	{
+	  MYSQL_NET_WRITE_DONE(1);
+	  DBUG_RETURN(1);
+	}
       packet+= len;
       length-= MAX_PACKET_LENGTH;
       len= MAX_PACKET_LENGTH;
@@ -459,9 +478,11 @@
   }
   int3store(buff,length);
   buff[3]= (uchar) net->pkt_nr++;
-  DBUG_RETURN(test(net_write_buff(net, buff, header_size) ||
-                   (head_len && net_write_buff(net, header, head_len)) ||
-                   net_write_buff(net, packet, len) || net_flush(net)));
+  rc = test(net_write_buff(net, buff, header_size) ||
+	    (head_len && net_write_buff(net, header, head_len)) ||
+	    net_write_buff(net, packet, len) || net_flush(net));
+  MYSQL_NET_WRITE_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 /**
@@ -989,6 +1010,8 @@
 {
   size_t len, complen;
 
+  MYSQL_NET_READ_START();
+
 #ifdef HAVE_COMPRESS
   if (!net->compress)
   {
@@ -1012,6 +1035,7 @@
     net->read_pos = net->buff + net->where_b;
     if (len != packet_error)
       net->read_pos[len]=0;		/* Safeguard for mysql_use_result */
+    MYSQL_NET_READ_DONE(0,len);
     return len;
 #ifdef HAVE_COMPRESS
   }
@@ -1095,7 +1119,10 @@
 
       net->where_b=buf_length;
       if ((packet_len = my_real_read(net,&complen)) == packet_error)
+      {
+	MYSQL_NET_READ_DONE(1,0);
 	return packet_error;
+      }
       if (my_uncompress(net->buff + net->where_b, packet_len,
 			&complen))
       {
@@ -1104,6 +1131,7 @@
 #ifdef MYSQL_SERVER
 	my_error(ER_NET_UNCOMPRESS_ERROR, MYF(0));
 #endif
+	MYSQL_NET_READ_DONE(1,0);
 	return packet_error;
       }
       buf_length+= complen;
@@ -1118,6 +1146,7 @@
     net->read_pos[len]=0;		/* Safeguard for mysql_use_result */
   }
 #endif /* HAVE_COMPRESS */
+  MYSQL_NET_READ_DONE(0,len);
   return len;
 }
 
diff -Nru sql/sp_head.cc sql/sp_head.cc
--- sql/sp_head.cc	2011-05-27 11:02:48.000000000 +0200
+++ sql/sp_head.cc	2011-05-27 10:50:57.000000000 +0200
@@ -22,6 +22,7 @@
 #include "sp_pcontext.h"
 #include "sp_rcontext.h"
 #include "sp_cache.h"
+#include "probes_mysql.h"
 
 /*
   Sufficient max length of printed destinations and frame offsets (all uints).
@@ -2904,7 +2905,14 @@
 int
 sp_instr_stmt::exec_core(THD *thd, uint *nextp)
 {
+  MYSQL_QUERY_EXEC_START(thd->query,
+                         thd->thread_id,
+                         (char *) (thd->db ? thd->db: ""),
+                         thd->security_ctx->priv_user,
+                         (char *) thd->security_ctx->host_or_ip,
+                         3);
   int res= mysql_execute_command(thd);
+  MYSQL_QUERY_EXEC_DONE(res);
   *nextp= m_ip+1;
   return res;
 }
diff -Nru sql/sql_cache.cc sql/sql_cache.cc
--- sql/sql_cache.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_cache.cc	2011-05-27 10:50:57.000000000 +0200
@@ -327,6 +327,7 @@
 */
 
 #include "mysql_priv.h"
+#include "probes_mysql.h"
 #ifdef HAVE_QUERY_CACHE
 #include <m_ctype.h>
 #include <my_dir.h>
@@ -1624,11 +1625,13 @@
   thd->main_da.disable_status();
 
   BLOCK_UNLOCK_RD(query_block);
+  MYSQL_QUERY_CACHE_HIT(thd->query, (ulong) thd->limit_found_rows);
   DBUG_RETURN(1);				// Result sent to client
 
 err_unlock:
   unlock();
 err:
+  MYSQL_QUERY_CACHE_MISS(thd->query);
   DBUG_RETURN(0);				// Query was not cached
 }
 
diff -Nru sql/sql_connect.cc sql/sql_connect.cc
--- sql/sql_connect.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_connect.cc	2011-05-27 10:50:57.000000000 +0200
@@ -38,6 +38,8 @@
 #define MIN_HANDSHAKE_SIZE      6
 #endif /* HAVE_OPENSSL */
 
+#include "probes.h"
+
 #ifdef __WIN__
 extern void win_install_sigabrt_handler();
 #endif
@@ -1119,6 +1121,9 @@
     if (login_connection(thd))
       goto end_thread;
 
+    MYSQL_CONNECTION_START(thd->thread_id, thd->security_ctx->priv_user,
+                           (char *) thd->security_ctx->host_or_ip);
+
     prepare_new_connection_state(thd);
 
     while (!net->error && net->vio != 0 &&
diff -Nru sql/sql_cursor.cc sql/sql_cursor.cc
--- sql/sql_cursor.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_cursor.cc	2011-05-27 10:50:57.000000000 +0200
@@ -19,6 +19,7 @@
 #include "mysql_priv.h"
 #include "sql_cursor.h"
 #include "sql_select.h"
+#include "probes_mysql.h"
 
 /****************************************************************************
   Declarations.
@@ -168,8 +169,14 @@
     thd->lock_id= sensitive_cursor->get_lock_id();
     thd->cursor= sensitive_cursor;
   }
-
+  MYSQL_QUERY_EXEC_START(thd->query,
+                         thd->thread_id,
+                         (char *) (thd->db ? thd->db : ""),
+                         thd->security_ctx->priv_user,
+                         (char *) thd->security_ctx->host_or_ip,
+                         2);
   rc= mysql_execute_command(thd);
+  MYSQL_QUERY_EXEC_DONE(rc);
 
   lex->result= save_result;
   thd->lock_id= &thd->main_lock_id;
diff -Nru sql/sql_delete.cc sql/sql_delete.cc
--- sql/sql_delete.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_delete.cc	2011-05-27 10:50:57.000000000 +0200
@@ -23,6 +23,7 @@
 #include "sql_select.h"
 #include "sp_head.h"
 #include "sql_trigger.h"
+#include "probes_mysql.h"
 
 /**
   Implement DELETE SQL word.
@@ -753,7 +754,10 @@
       if (table->triggers &&
           table->triggers->process_triggers(thd, TRG_EVENT_DELETE,
                                             TRG_ACTION_BEFORE, FALSE))
-        DBUG_RETURN(1);
+	{
+	  MYSQL_MULTI_DELETE_DONE(1, 0);
+	  DBUG_RETURN(1);
+	}
       table->status|= STATUS_DELETED;
       if (!(error=table->file->ha_delete_row(table->record[0])))
       {
@@ -781,10 +785,12 @@
       if (error)
       {
 	error= 1;                               // Fatal error
+	MYSQL_MULTI_DELETE_DONE(1, 0);
 	DBUG_RETURN(1);
       }
     }
   }
+  MYSQL_MULTI_DELETE_DONE(0, (ulong) deleted);
   DBUG_RETURN(0);
 }
 
@@ -1028,7 +1034,9 @@
   table_list->lock_type= TL_WRITE;
   mysql_init_select(thd->lex);
   thd->clear_current_stmt_binlog_row_based();
+  MYSQL_DELETE_START(thd->query);
   error= mysql_delete(thd, table_list, NULL, NULL, HA_POS_ERROR, LL(0), TRUE);
+  MYSQL_DELETE_DONE(error, (ulong) thd->row_count_func);
   ha_autocommit_or_rollback(thd, error);
   end_trans(thd, error ? ROLLBACK : COMMIT);
   thd->current_stmt_binlog_row_based= save_binlog_row_based;
diff -Nru sql/sql_insert.cc sql/sql_insert.cc
--- sql/sql_insert.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_insert.cc	2011-05-27 10:50:57.000000000 +0200
@@ -61,6 +61,7 @@
 #include "sql_show.h"
 #include "slave.h"
 #include "rpl_mi.h"
+#include "probes_mysql.h"
 
 #ifndef EMBEDDED_LIBRARY
 static bool delayed_get_table(THD *thd, TABLE_LIST *table_list);
@@ -598,18 +599,25 @@
   {
     my_error(ER_DELAYED_INSERT_TABLE_LOCKED, MYF(0),
              table_list->table_name);
+    MYSQL_INSERT_DONE(1, 0);
     DBUG_RETURN(TRUE);
   }
 
   if (table_list->lock_type == TL_WRITE_DELAYED)
   {
     if (open_and_lock_for_insert_delayed(thd, table_list))
-      DBUG_RETURN(TRUE);
+      {
+	MYSQL_INSERT_DONE(1, 0);
+	DBUG_RETURN(TRUE);
+      }
   }
   else
   {
     if (open_and_lock_tables(thd, table_list))
-      DBUG_RETURN(TRUE);
+      {
+	MYSQL_INSERT_DONE(1, 0);
+	DBUG_RETURN(TRUE);
+      }
   }
   lock_type= table_list->lock_type;
 
@@ -957,6 +965,7 @@
     ::my_ok(thd, (ulong) thd->row_count_func, id, buff);
   }
   thd->abort_on_warning= 0;
+  MYSQL_INSERT_DONE(1, (ulong) thd->row_count_func);
   DBUG_RETURN(FALSE);
 
 abort:
@@ -969,6 +978,7 @@
   if (!joins_freed)
     free_underlaid_joins(thd, &thd->lex->select_lex);
   thd->abort_on_warning= 0;
+  MYSQL_INSERT_DONE(1, 0);
   DBUG_RETURN(TRUE);
 }
 
@@ -3249,6 +3259,7 @@
   if (error)
   {
     table->file->print_error(error,MYF(0));
+    MYSQL_INSERT_SELECT_DONE(error, 0);
     DBUG_RETURN(1);
   }
   char buff[160];
@@ -3268,6 +3279,7 @@
      thd->first_successful_insert_id_in_prev_stmt :
      (info.copied ? autoinc_value_of_last_inserted_row : 0));
   ::my_ok(thd, (ulong) thd->row_count_func, id, buff);
+  MYSQL_INSERT_DONE(0, (ulong) thd->row_count_func);
   DBUG_RETURN(0);
 }
 
@@ -3324,6 +3336,12 @@
     table->file->ha_release_auto_increment();
   }
 
+  if (MYSQL_INSERT_SELECT_DONE_ENABLED())
+    {
+      MYSQL_INSERT_SELECT_DONE(1, (ulong) (info.copied + info.deleted +
+					   info.updated));
+    }
+
   DBUG_VOID_RETURN;
 }
 
